\section{Related works}
\label{sec_related_works}
Our work is related to auto-scaling.

Products with auto-scaling already exist \cite{amazon_aws_2018, barr_new_2018, noauthor_microsoft_2017, noauthor_google_2018, noauthor_kubernetes_autoscaler_2019}.
The majority of the existing approaches use horizontal scaling (\textit{i.e.} add or delete a VM or a container).

Amazon approach is particularly relevant because it supports vertical scaling (\textit{i.e.} giving to or taking resources from a VM or a container).
With Amazon Web Services, allocated resources can be modified dynamically through prediction.
This dynamic scaling will add or delete resources to maintain their use at fixed levels.
The predictive scaling analyzes up to 14 days of a metric use and is able to make prediction on 2 days.
The prediction grain is an hour.
This auto scaling will add or delete resources to conform with the prediction.
If the prediction was too weak the dynamic scaling will be activated.
The predictive scaling is based on machine learning \cite{amazon_aws_2018}.

In research, such solutions also exist \cite{kriushanth_load_2015, lorido_botran_review_2014, moore_transforming_2013, rao_distributed_2011}.
Some use horizontal scaling \cite{kriushanth_load_2015, moore_transforming_2013}.
Lorido-Botran \textit{et al.} do horizontal scaling for containers.
They monitor the requests received by their web application during a given period.
They analyze and predict the number of requests to come during the next period.
Then, they compute the number of containers needed to face those requests \cite{lorido_botran_review_2014}.

The solution of Rao \textit{et al.} implements vertical scaling for VM.
A decision (\textit{i.e.} add or remove resources) will be assessed to know if it increases VM's performance.
Otherwise, the system will learn to not take this decision anymore \cite{rao_distributed_2011}.

About memory consolidation, the most famous technique is the memory ballooning \cite{kim_dynamic_2015, salomie_application_2013, kvm_automatic_2013, capitulino_automatic_2013, qemu_qemu_2019}.
This technique permits giving or taking memory from a VM.
A balloon will be inflated by the host OS by taking memory from a VM or deflated to give memory to another VM.
The guest OS must be adapted to use this technique.
\texttt{Qemu} offers a special driver for guest OS \cite{qemu_qemu_2019}

Kim \textit{et al.} make ballooning aware of memory pressure \cite{kim_dynamic_2015} .
They define different levels of memory pressure, which allows their solution to be reactive.

Carver \textit{et al.} focus on containers \cite{carver_acdc_2017}.
Since, under memory pressure, all memory \texttt{cgroups} are reclaimed they propose to modify the memory reclamation algorithm, to target first the least recently active container.
This solution avoids performance drop of active containers because they are not reclaimed anymore.

Compared to all these works, ours is unique in the way that we offer memory consolidation for containers.
NHRS is also original in the way that it bases its reclaim on containers' performance as reported by probes.